﻿using System.Collections.Generic;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Components;
using UserService.DatabaseLayer.DataModels;
using UserService.DatabaseLayer.Repository;

namespace UserService.Pages
{
    public class OrganizationUnitsBase : ComponentBase
    {
        [Inject] private IOrganizationUnitsRepository OrganizationUnitsRepository { get; set; } = null!;

        protected bool DialogIsOpen { get; set; }
        protected OrganizationUnit? OuToEdit { get; private set; }

        protected IReadOnlyList<OrganizationUnit>? OrganizationUnits { get; private set; }

        protected override async Task OnInitializedAsync()
        {
            OrganizationUnits = await OrganizationUnitsRepository.GetAllAsync().ConfigureAwait(false);
        }

        protected void Edit(OrganizationUnit organizationUnit)
        {
            DialogIsOpen = true;
            OuToEdit = organizationUnit;
        }

        protected async Task OkClick()
        {
            if (OuToEdit is null) return;
            await OrganizationUnitsRepository.UpdateAsync(OuToEdit).ConfigureAwait(false);
            DialogIsOpen = false;
        }

        protected async Task Delete(OrganizationUnit organizationUnit)
        {
            await OrganizationUnitsRepository.DeleteAsync(organizationUnit).ConfigureAwait(false);
        }
    }
}